<?php

class ConotoxiaPaySuccessModuleFrontController extends ModuleFrontController
{
    public function initContent()
    {
        parent::initContent();

        $conPay = new ConotoxiaPay();
        $conotoxiaPay = $conPay->initializeConotoxiaPay();
        $paymentManager = new CKPL\Pay\Payment\PaymentManager($conotoxiaPay);
        $urlReturnData = Tools::getValue('data');
        $decodedReturn = $paymentManager->decodeReturn($urlReturnData);
        $paymentId = $decodedReturn->getPaymentId();
        $orderId = $decodedReturn->getExternalPaymentId();

        $order = new Order($orderId);
        $orderPayments = $order->getOrderPayments();
        $validOrder = $this->validateOrder($orderPayments, $paymentId);

        $this->context->smarty->assign(array(
            'smallLogo' => $conPay->getLogo(),
            'paymentId' => $paymentId,
            'paymentResult' => $validOrder ? $decodedReturn->getResult() : 'ERROR'
        ));
        $this->setTemplate($conPay->buildTemplatePath('payment_return'));
    }

    /**
     * @param array $orderPayments
     * @param string $paymentId
     * @return bool
     */
    private function validateOrder(array $orderPayments, string $paymentId)
    {
        if ($orderPayments == null || empty($orderPayments)) {
            return false;
        }
        foreach ($orderPayments as $payment) {
            if ($payment->transaction_id === $paymentId) {
                return true;
            }
        }
        return false;
    }
}
