<?php

declare(strict_types=1);

namespace PrestaShop\Module\ConotoxiaPay\Repository;

use Db;

/**
 * Class PaymentRepository
 * @package PrestaShop\Module\ConotoxiaPay\Repository
 */
class PaymentRepository
{
    /**
     * @param string $id_payment
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     * @throws \PrestaShopDatabaseException
     */
    public static function isBooked($id_payment)
    {
        $result = Db::getInstance(_PS_USE_SQL_SLAVE_)->executeS('
            SELECT `status` 
            FROM `' . _DB_PREFIX_ . 'conpay_payment` 
            WHERE `id_payment` = \'' . $id_payment . '\''
        );
        if (isset($result[0]['status'])) {
            return $result[0]['status'] === 'BOOKED';
        }
        return false;
    }

    /**
     * @param string $id_payment
     * @param string $status
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     */
    public static function updatePaymentStatus($id_payment, $status)
    {
        return Db::getInstance(_PS_USE_SQL_SLAVE_)->execute('
            UPDATE `' . _DB_PREFIX_ . 'conpay_payment` 
            SET `status` = \'' . $status . '\'
            WHERE `id_payment` = \'' . $id_payment . '\''
        );
    }

    /**
     * @param int $id_order
     * @param string $id_payment
     * @return array|false|\mysqli_result|\PDOStatement|resource|null
     */
    public static function createPayment($id_order, $id_payment)
    {
        return Db::getInstance(_PS_USE_SQL_SLAVE_)->execute('
        INSERT INTO `' . _DB_PREFIX_ . 'conpay_payment` (
            `status`, 
            `id_payment`, 
            `id_order`
        ) VALUES (
            \'UNKNOWN\',
            \'' . $id_payment . '\',
            ' . $id_order . '
        )');
    }
}